diff --git a/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py b/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py
index 46a326da..b18145e0 100644
--- a/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py
+++ b/web/pgadmin/tools/sqleditor/utils/query_tool_preferences.py
@@ -197,7 +197,7 @@ def register_query_tool_preferences(self):
         options=[{'label': gettext('None'), 'value': 'none'},
                  {'label': gettext('All'), 'value': 'all'},
                  {'label': gettext('Strings'), 'value': 'strings'}],
-        select2={
+        control_props={
             'allowClear': False,
             'tags': False
         }
@@ -209,9 +209,9 @@ def register_query_tool_preferences(self):
         category_label=PREF_LABEL_CSV_TXT,
         options=[{'label': '"', 'value': '"'},
                  {'label': '\'', 'value': '\''}],
-        select2={
+        control_props={
             'allowClear': False,
-            'tags': True
+            'tags': False
         }
     )
 
@@ -223,9 +223,9 @@ def register_query_tool_preferences(self):
                  {'label': ',', 'value': ','},
                  {'label': '|', 'value': '|'},
                  {'label': gettext('Tab'), 'value': '\t'}],
-        select2={
+        control_props={
             'allowClear': False,
-            'tags': True
+            'tags': False
         }
     )
 
@@ -247,7 +247,7 @@ def register_query_tool_preferences(self):
         options=[{'label': gettext('None'), 'value': 'none'},
                  {'label': gettext('All'), 'value': 'all'},
                  {'label': gettext('Strings'), 'value': 'strings'}],
-        select2={
+        control_props={
             'allowClear': False,
             'tags': False
         }
@@ -259,9 +259,9 @@ def register_query_tool_preferences(self):
         category_label=PREF_LABEL_RESULTS_GRID,
         options=[{'label': '"', 'value': '"'},
                  {'label': '\'', 'value': '\''}],
-        select2={
+        control_props={
             'allowClear': False,
-            'tags': True
+            'tags': False
         }
     )
 
@@ -273,9 +273,9 @@ def register_query_tool_preferences(self):
                  {'label': ',', 'value': ','},
                  {'label': '|', 'value': '|'},
                  {'label': gettext('Tab'), 'value': '\t'}],
-        select2={
+        control_props={
             'allowClear': False,
-            'tags': True
+            'tags': False
         }
     )
 
diff --git a/web/pgadmin/utils/preferences.py b/web/pgadmin/utils/preferences.py
index 09011804..e07424cb 100644
--- a/web/pgadmin/utils/preferences.py
+++ b/web/pgadmin/utils/preferences.py
@@ -66,10 +66,11 @@ class _Preference(object):
         self.label = label
         self._type = _type
         self.help_str = kwargs.get('help_str', None)
+        self.control_props = kwargs.get('control_props', None)
         self.min_val = kwargs.get('min_val', None)
         self.max_val = kwargs.get('max_val', None)
         self.options = kwargs.get('options', None)
-        self.select2 = kwargs.get('select2', None)
+        self.select = kwargs.get('select', None)
         self.fields = kwargs.get('fields', None)
         self.allow_blanks = kwargs.get('allow_blanks', None)
         self.disabled = kwargs.get('disabled', False)
@@ -146,10 +147,10 @@ class _Preference(object):
             for opt in self.options:
                 if 'value' in opt and opt['value'] == res.value:
                     return True, res.value
-            if self.select2 and self.select2['tags']:
+            if self.select and self.select['tags']:
                 return True, res.value
             return True, self.default
-        if self._type == 'select2':
+        if self._type == 'select':
             if res.value:
                 res.value = res.value.replace('[', '')
                 res.value = res.value.replace(']', '')
@@ -190,7 +191,7 @@ class _Preference(object):
                 has_value = next((True for opt in self.options
                                   if 'value' in opt and opt['value'] == value),
                                  False)
-                assert (has_value or (self.select2 and self.select2['tags']))
+                assert (has_value or (self.select and self.select['tags']))
             elif self._type == 'date':
                 value = parser_map[self._type](value).date()
             else:
@@ -248,10 +249,11 @@ class _Preference(object):
             'label': self.label or self.name,
             'type': self._type,
             'help_str': self.help_str,
+            'control_props': self.control_props,
             'min_val': self.min_val,
             'max_val': self.max_val,
             'options': self.options,
-            'select2': self.select2,
+            'select': self.select,
             'value': self.get(),
             'fields': self.fields,
             'disabled': self.disabled,
@@ -393,7 +395,7 @@ class Preferences(object):
         return res
 
     def register(
-            self, category, name, label, _type, default, **kwargs
+        self, category, name, label, _type, default, **kwargs
     ):
         """
         register
@@ -414,7 +416,7 @@ class Preferences(object):
         :param options:
         :param help_str:
         :param category_label:
-        :param select2: select2 control extra options
+        :param select: select control extra options
         :param fields: field schema (if preference has more than one field to
                         take input from user e.g. keyboardshortcut preference)
         :param allow_blanks: Flag specify whether to allow blank value.
@@ -424,8 +426,9 @@ class Preferences(object):
         max_val = kwargs.get('max_val', None)
         options = kwargs.get('options', None)
         help_str = kwargs.get('help_str', None)
+        control_props = kwargs.get('control_props', {})
         category_label = kwargs.get('category_label', None)
-        select2 = kwargs.get('select2', None)
+        select = kwargs.get('select', None)
         fields = kwargs.get('fields', None)
         allow_blanks = kwargs.get('allow_blanks', None)
         disabled = kwargs.get('disabled', False)
@@ -440,14 +443,15 @@ class Preferences(object):
         assert _type in (
             'boolean', 'integer', 'numeric', 'date', 'datetime',
             'options', 'multiline', 'switch', 'node', 'text', 'radioModern',
-            'keyboardshortcut', 'select2', 'selectFile', 'threshold'
+            'keyboardshortcut', 'select', 'selectFile', 'threshold'
         ), "Type cannot be found in the defined list!"
 
         (cat['preferences'])[name] = res = _Preference(
             cat['id'], name, label, _type, default, help_str=help_str,
             min_val=min_val, max_val=max_val, options=options,
-            select2=select2, fields=fields, allow_blanks=allow_blanks,
-            disabled=disabled, dependents=dependents
+            select=select, fields=fields, allow_blanks=allow_blanks,
+            disabled=disabled, dependents=dependents,
+            control_props=control_props
         )
 
         return res
@@ -483,7 +487,7 @@ class Preferences(object):
 
     @classmethod
     def register_preference(
-            cls, module, category, name, label, _type, **kwargs
+        cls, module, category, name, label, _type, **kwargs
     ):
         """
         register
@@ -503,6 +507,7 @@ class Preferences(object):
         max_val = kwargs.get('max_val', None)
         options = kwargs.get('options', None)
         help_str = kwargs.get('help_str', None)
+        control_props = kwargs.get('control_props', None)
         module_label = kwargs.get('module_label', None)
         category_label = kwargs.get('category_label', None)
 
@@ -516,6 +521,7 @@ class Preferences(object):
         return m.register(
             category, name, label, _type, default, min_val=min_val,
             max_val=max_val, options=options, help_str=help_str,
+            control_props=control_props,
             category_label=category_label
         )
 
diff --git a/web/regression/javascript/components/KeyboardShortcuts.spec.js b/web/regression/javascript/components/KeyboardShortcuts.spec.js
new file mode 100644
index 00000000..1a92ff88
--- /dev/null
+++ b/web/regression/javascript/components/KeyboardShortcuts.spec.js
@@ -0,0 +1,100 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { withTheme } from '../fake_theme';
+import { createMount } from '@material-ui/core/test-utils';
+import {
+  OutlinedInput,
+} from '@material-ui/core';
+import KeyboardShortcuts from '../../../pgadmin/static/js/components/KeyboardShortcuts';
+
+/* MUI Components need to be wrapped in Theme for theme vars */
+describe('KeyboardShortcuts', () => {
+  let mount;
+  let defult_value = {
+    'ctrl': true,
+    'alt': true,
+    'key': {
+      'char': 'a',
+      'key_code': 97
+    }
+  };
+  let fields = [{
+    type: 'keyCode',
+    label: 'Key'
+  }, {
+    name: 'shift',
+    label: 'Shift',
+    type: 'checkbox'
+  },
+  {
+    name: 'control',
+    label: 'Control',
+    type: 'checkbox'
+  },
+  {
+    name: 'alt',
+    label: 'Alt/Option',
+    type: 'checkbox'
+  }];
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(() => {
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(() => {
+    jasmineEnzyme();
+  });
+
+  describe('KeyboardShortcuts', () => {
+    let ThemedFormInputKeyboardShortcuts = withTheme(KeyboardShortcuts), ctrl;
+
+    beforeEach(() => {
+      ctrl = mount(
+        <ThemedFormInputKeyboardShortcuts
+          testcid="inpCid"
+          helpMessage="some help message"
+          /* InputText */
+          readonly={false}
+          disabled={false}
+          maxlength={1}
+          value={defult_value}
+          fields={fields}
+          controlProps={{
+            extraprop: 'test'
+          }}
+        />);
+    });
+
+    it('init', () => {
+      expect(ctrl.find(OutlinedInput).prop('value')).toBe('a');
+    });
+
+    it('Key change', () => {
+      let onChange = () => {/*This is intentional (SonarQube)*/ };
+      ctrl.setProps({
+        controlProps: {
+          onKeyDown: onChange
+        }
+      });
+
+      expect(ctrl.find(OutlinedInput).prop('value')).toBe('a');
+    });
+  });
+
+});
diff --git a/web/regression/javascript/components/QueryThreshold.spec.js b/web/regression/javascript/components/QueryThreshold.spec.js
new file mode 100644
index 00000000..fa259ae0
--- /dev/null
+++ b/web/regression/javascript/components/QueryThreshold.spec.js
@@ -0,0 +1,86 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { withTheme } from '../fake_theme';
+import { createMount } from '@material-ui/core/test-utils';
+import {
+  OutlinedInput,
+} from '@material-ui/core';
+import QueryThresholds from '../../../pgadmin/static/js/components/QueryThresholds';
+
+/* MUI Components need to be wrapped in Theme for theme vars */
+describe('QueryThresholds', () => {
+  let mount;
+  let defult_value = {
+    'warning': 5,
+    'alert': 6
+  };
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(() => {
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(() => {
+    jasmineEnzyme();
+  });
+
+  describe('QueryThresholds', () => {
+    let ThemedFormInputQueryThresholds = withTheme(QueryThresholds), ctrl;
+
+    beforeEach(() => {
+      ctrl = mount(
+        <ThemedFormInputQueryThresholds
+          testcid="inpCid"
+          helpMessage="some help message"
+          /* InputText */
+          readonly={false}
+          disabled={false}
+          maxlength={1}
+          value={defult_value}
+          controlProps={{
+            extraprop: 'test'
+          }}
+        />);
+    });
+
+    it('init Warning', () => {
+      expect(ctrl.find(OutlinedInput).at(0).prop('value')).toBe(5);
+    });
+
+    it('init Alert', () => {
+      expect(ctrl.find(OutlinedInput).at(1).prop('value')).toBe(6);
+    });
+
+    it('warning change', () => {
+      let onChange = () => {/*This is intentional (SonarQube)*/ };
+      ctrl.setProps({
+        onChange: onChange
+      });
+      expect(ctrl.find(OutlinedInput).at(0).prop('value')).toBe(5);
+    });
+
+    it('Alert change', () => {
+      let onChange = () => {/*This is intentional (SonarQube)*/ };
+      ctrl.setProps({
+        onChange: onChange
+      });
+      expect(ctrl.find(OutlinedInput).at(1).prop('value')).toBe(6);
+    });
+  });
+
+});
diff --git a/web/regression/javascript/schema_ui_files/binary_path.ui.spec.js b/web/regression/javascript/schema_ui_files/binary_path.ui.spec.js
new file mode 100644
index 00000000..f51dfefc
--- /dev/null
+++ b/web/regression/javascript/schema_ui_files/binary_path.ui.spec.js
@@ -0,0 +1,44 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import {genericBeforeEach, getPropertiesView} from '../genericFunctions';
+import {getBinaryPathSchema} from '../../../pgadmin/browser/server_groups/servers/static/js/binary_path.ui';
+
+describe('BinaryPathschema', ()=>{
+  let mount;
+  let schemaObj = getBinaryPathSchema();
+  let getInitData = ()=>Promise.resolve({});
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    genericBeforeEach();
+  });
+
+  it('edit', ()=>{
+    mount(getPropertiesView(schemaObj, getInitData));
+  });
+
+  it('validate path', ()=>{
+    let validate = _.find(schemaObj.fields, (f)=>f.id=='binaryPath').validate;
+    let status = validate('/test/');
+    expect(status).toBe(true);
+  });
+
+});
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index f45efde8..a2e8f28e 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -282,7 +282,7 @@ var webpackShimConfig = {
     'pgadmin.node.user_mapping': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/user_mappings/static/js/user_mapping'),
     'pgadmin.node.view': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/view'),
     'pgadmin.node.row_security_policy': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/schemas/tables/row_security_policies/static/js/row_security_policy'),
-    'pgadmin.preferences': path.join(__dirname, './pgadmin/preferences/static/js/preferences'),
+    'pgadmin.preferences': path.join(__dirname, './pgadmin/preferences/static/js/'),
     'pgadmin.settings': path.join(__dirname, './pgadmin/settings/static/js/settings'),
     'pgadmin.server.supported_servers': '/browser/server/supported_servers',
     'pgadmin.sqleditor': path.join(__dirname, './pgadmin/tools/sqleditor/static/js/sqleditor'),
